# coding: utf-8

"""
    Suger API

    CRUD operations on a set of resources, including organizations, products, offers, entitlements, usage record groups for meterting, etc.

    The version of the OpenAPI document: 1.0
    Contact: support@suger.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from suger_sdk_python.models.aws_marketplace_metering_tag import AwsMarketplaceMeteringTag
from typing import Optional, Set
from typing_extensions import Self

class AwsMarketplaceMeteringUsageAllocation(BaseModel):
    """
    AwsMarketplaceMeteringUsageAllocation
    """ # noqa: E501
    allocated_usage_quantity: Optional[StrictInt] = Field(default=None, description="The total quantity allocated to this bucket of usage.", alias="AllocatedUsageQuantity")
    tags: Optional[List[AwsMarketplaceMeteringTag]] = Field(default=None, description="The set of tags that define the bucket of usage. For the bucket of items with no tags, this parameter can be left out.", alias="Tags")
    __properties: ClassVar[List[str]] = ["AllocatedUsageQuantity", "Tags"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AwsMarketplaceMeteringUsageAllocation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in tags (list)
        _items = []
        if self.tags:
            for _item_tags in self.tags:
                if _item_tags:
                    _items.append(_item_tags.to_dict())
            _dict['Tags'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AwsMarketplaceMeteringUsageAllocation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "AllocatedUsageQuantity": obj.get("AllocatedUsageQuantity"),
            "Tags": [AwsMarketplaceMeteringTag.from_dict(_item) for _item in obj["Tags"]] if obj.get("Tags") is not None else None
        })
        return _obj


