# coding: utf-8

"""
    Suger API

    CRUD operations on a set of resources, including organizations, products, offers, entitlements, usage record groups for meterting, etc.

    The version of the OpenAPI document: 1.0
    Contact: support@suger.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from suger_sdk_python.models.revenue_report_type import RevenueReportType
from typing import Optional, Set
from typing_extensions import Self

class GetRevenueReportParams(BaseModel):
    """
    GetRevenueReportParams
    """ # noqa: E501
    buyer_id: Optional[StrictStr] = Field(default=None, description="Optional, if available, return the report for the Buyer.", alias="buyerID")
    entitlement_id: Optional[StrictStr] = Field(default=None, description="Optional, if available, return the report for the Entitlement.", alias="entitlementID")
    organization_id: StrictStr = Field(description="Required. If the productID & entitlementID are emtpy, return the report for the entire Organization.", alias="organizationID")
    partner: StrictStr
    product_id: Optional[StrictStr] = Field(default=None, description="Optional, if available, return the report for the Product.", alias="productID")
    report_type: RevenueReportType = Field(alias="reportType")
    service: StrictStr
    __properties: ClassVar[List[str]] = ["buyerID", "entitlementID", "organizationID", "partner", "productID", "reportType", "service"]

    @field_validator('partner')
    def partner_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['AWS', 'AZURE', 'GCP']):
            raise ValueError("must be one of enum values ('AWS', 'AZURE', 'GCP')")
        return value

    @field_validator('service')
    def service_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['MARKETPLACE']):
            raise ValueError("must be one of enum values ('MARKETPLACE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetRevenueReportParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetRevenueReportParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "buyerID": obj.get("buyerID"),
            "entitlementID": obj.get("entitlementID"),
            "organizationID": obj.get("organizationID"),
            "partner": obj.get("partner"),
            "productID": obj.get("productID"),
            "reportType": obj.get("reportType"),
            "service": obj.get("service")
        })
        return _obj


