# coding: utf-8

"""
    Suger API

    CRUD operations on a set of resources, including organizations, products, offers, entitlements, usage record groups for meterting, etc.

    The version of the OpenAPI document: 1.0
    Contact: support@suger.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from suger_sdk_python.models.notification_event import NotificationEvent
from typing import Optional, Set
from typing_extensions import Self

class ListNotificationEventsResponse(BaseModel):
    """
    ListNotificationEventsResponse
    """ # noqa: E501
    next_offset: Optional[StrictInt] = Field(default=None, description="If it is nil, it means there is no more records.", alias="nextOffset")
    notification_events: Optional[List[NotificationEvent]] = Field(default=None, alias="notificationEvents")
    total_count: Optional[StrictInt] = Field(default=None, description="Only available when the request is made with offset=0.", alias="totalCount")
    __properties: ClassVar[List[str]] = ["nextOffset", "notificationEvents", "totalCount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListNotificationEventsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in notification_events (list)
        _items = []
        if self.notification_events:
            for _item_notification_events in self.notification_events:
                if _item_notification_events:
                    _items.append(_item_notification_events.to_dict())
            _dict['notificationEvents'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListNotificationEventsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "nextOffset": obj.get("nextOffset"),
            "notificationEvents": [NotificationEvent.from_dict(_item) for _item in obj["notificationEvents"]] if obj.get("notificationEvents") is not None else None,
            "totalCount": obj.get("totalCount")
        })
        return _obj


